//+------------------------------------------------------------------+
//|                                                MA_with_canal.mq4 |
//|                     Copyright  2009,    |
//|                                         e-mail: buga1922@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009,   "
#property link "mailto:buga1922@mail.ru"

#property indicator_chart_window          //     
#property indicator_buffers 3             //    = 3
#property indicator_color1 Red            //  1-  - 
#property indicator_color2 Red            //  2-  - 
#property indicator_color3 Red            //  3-  - 
#property indicator_width3  2             //    - 2

//     
double Buffer1[],
       Buffer2[],
       Buffer3[];

//   

extern double ma_canal = 2;               //       (ma_canal*__)
extern int    ma_period = 21,             //     
              ma_method=3,                //    0- SMA, 1- EMA, 2- SMMA,
                                          //  3-- LWMA
              ma_cena=0;                  //      0- , 1- , 2-, 3-,
                                          //  4-, 5-, 6-  
                                          
//     
string ma_method_str,ma_cena_str;                                     

                         //--- ---//
                         
// ,    
void PARAMETRY()
 {
  switch(ma_method)
   {
    case 0:  ma_method_str = "  (SMA)";             break;
    case 1:  ma_method_str = "  (EMA)";    break;
    case 2:  ma_method_str = "  (SMMA)";         break;
    case 3:  ma_method_str = "-  (LWMA)"; break;
    default: ma_method_str = "  ";      break;
   }
  switch(ma_cena)
   {
    case 0:  ma_cena_str = "  (PRICE_CLOSE)";               break;
    case 1:  ma_cena_str = "  (PRICE_OPEN)";                break;
    case 2:  ma_cena_str = "  (PRICE_HIGH)";            break;
    case 3:  ma_cena_str = "  (PRICE_LOW)";              break;
    case 4:  ma_cena_str = "  (PRICE_MEDIAN)";               break;
    case 5:  ma_cena_str = "  (PRICE_TYPICAL)";             break;
    case 6:  ma_cena_str = "   (PRICE_WEIGHTED)"; break;
    default: ma_cena_str = "  ";              break;
   }
 }

//       ,
//      .  true,    .
bool PROVERKA()
 {
  //     
  ObjectDelete("error"); 
  ObjectDelete("advice");
  return(true);
  //     
  if ( ma_canal < 0)
   {
    VYVOD(":   ma_canal.","   ");return(false);
   }
  else 
   {
    if ( ( ma_period < 0) || ( ma_period > Bars-2) )
     {
      VYVOD(":   ma_period.","     [0;"+(Bars-2)+"]");return(false);
     }
    else
     {
      if ( ( ma_method < 0) || ( ma_method > 3) )
       {
        VYVOD(":   ma_method.","     [0;3]");return(false);
       }
      else
       {
        if ( ( ma_cena < 0) || ( ma_cena > 6) )
         {
          VYVOD(":   ma_cena.","     [0;6]");return(false);
         }
       } 
     }
   }
 }  

//       
void VYVOD(string error, string advice)
 {
  ObjectCreate  ( "error", OBJ_LABEL,0,0,0);                                 //  ,    
                                                                             //    
  ObjectSetText ( "error", " MA_with_canal"+error,12,"Arial", Red); //     
  ObjectSet     ( "error", OBJPROP_CORNER,    1);                            //     ( )
  ObjectSet     ( "error", OBJPROP_XDISTANCE,15);                            //      
  ObjectSet     ( "error", OBJPROP_YDISTANCE,15);                            //      
  
  ObjectCreate  ( "advice", OBJ_LABEL,0,0,0);                                //  ,    
                                                                             //     
  ObjectSetText ( "advice", advice,12,"Arial", Red);                         //     
  ObjectSet     ( "advice", OBJPROP_CORNER,    1);                           //     ( )          
  ObjectSet     ( "advice", OBJPROP_XDISTANCE,15);                           //      
  ObjectSet     ( "advice", OBJPROP_YDISTANCE,40);                           //      
 }

double canal(int lag)
 {
  int i;
  double sum=0;
  for (i=lag; i<=lag+ma_period; i++)  sum=sum+(High[i]-Low[i]);
  return(sum/ma_period*ma_canal);
 }
 
//     
void RASSCHET()
  {
   double MA;
   
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)   counted_bars--;
   int bars = Bars - counted_bars;
   if(counted_bars==0) bars-=1+ma_period;
      
   while ( bars > 0 )
      {
       MA=iMA(Symbol(),0,ma_period,0,ma_method,ma_cena,bars);
       Buffer1[bars]=( MA + canal(bars));
       Buffer2[bars]=( MA - canal(bars));
       Buffer3[bars]=MA;
       bars--;
      }
  }

//  
void init()
  {
   //    -  ,  - ,    
   SetIndexStyle (0, DRAW_LINE, STYLE_SOLID); 
   SetIndexStyle (1, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle (2, DRAW_LINE, STYLE_SOLID);
   
   //   Buffer    
   SetIndexBuffer (0, Buffer1);              
   SetIndexBuffer (1, Buffer2);
   SetIndexBuffer (2, Buffer3);
  
   //    
   SetIndexLabel (0, "high_limit");
   SetIndexLabel (1, "low_limit");
   SetIndexLabel (2, "MA");
   
   //    
   IndicatorShortName("MA_with_canal ("+ma_period+";"+ DoubleToStr(ma_canal,1)+")");
   
   PARAMETRY(); //       
  }

//  
void deinit()
  { 
   //       
   Comment("");
   ObjectDelete("error"); 
   ObjectDelete("advice");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start()
  {
   if ( PROVERKA() == true)
    {
     RASSCHET();
    }
   Comment(" MA_with_canal\n  ="+ma_period+
           ";    ="+DoubleToStr(ma_canal,1)+
           "\n    "+ma_cena_str+
           "\n    - "+ma_method_str+
           "\n  ="+DoubleToStr(canal(0),4));
  }
 
//+------------------------------------------------------------------+